// @(#)$Id: TotalCompareTo.java,v 1.6 2003/11/01 00:39:37 leavens Exp $

// Copyright (C) 2002 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.models.resolve;

/** Objects whose compareTo operation is guaranteed not to throw an
 *  {@link UndefinedException} and only throws a ClassCastException
 *  when the class of the argument prohibits comparison.
 *
 * @version $Revision: 1.6 $
 * @author Gary T. Leavens
 */
public interface TotalCompareTo extends ReflexiveCompareTo {

    /*@ also
      @   public behavior
      @     ensures obj != null && obj instanceof TotalCompareTo;
      @     signals (ClassCastException)
      @             obj == null || !(obj instanceof TotalCompareTo);
      @*/
    /*@ pure @*/ int compareTo(Object obj);

    /*@ also
      @   public model_program {
      @     try {
      @       int r = this.compareTo(obj);
      @     } catch (ClassCastException e) {
      @       return false;
      @     }
      @     return true;
      @   }
      @*/
      //@ pure model boolean isComparableTo(Object obj);
}

