// @(#)$Id: TransitiveCompareTo.java,v 1.5 2003/11/01 00:39:37 leavens Exp $

// Copyright (C) 2002 Iowa State University

// This file is part of JML

// JML is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.

// JML is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with JML; see the file COPYING.  If not, write to
// the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

package org.jmlspecs.models.resolve;

/** Objects with a transitive compareTo operation.
 *
 * @version $Revision: 1.5 $
 * @author Gary T. Leavens
 */
public interface TransitiveCompareTo extends CompareTo {

    /*@ public instance invariant
      @      (\forall TransitiveCompareTo x, y, z;
      @              x != null && y != null && z != null
      @              && x.isComparableTo(y) && y.isComparableTo(z);
      @              x.compareTo(y) < 0 && y.compareTo(z) < 0
      @                 ==> x.isComparableTo(z) && x.compareTo(z) < 0);
      @ public instance invariant
      @      (\forall TransitiveCompareTo x, y, z;
      @              x != null && y != null && z != null
      @              && x.isComparableTo(y) && y.isComparableTo(z);
      @              x.compareTo(y) <= 0 && y.compareTo(z) <= 0
      @                 ==> x.isComparableTo(z) && x.compareTo(z) <= 0);
      @ public instance invariant
      @      (\forall TransitiveCompareTo x, y, z;
      @              x != null && y != null && z != null
      @              && x.isComparableTo(y) && y.isComparableTo(z);
      @              x.compareTo(y) == 0 && y.compareTo(z) == 0
      @                 ==> x.isComparableTo(z) && x.compareTo(z) == 0);
      @ public instance invariant_redundantly
      @      (\forall TransitiveCompareTo x, y, z;
      @              x != null && y != null && z != null
      @              && x.isComparableTo(y) && y.isComparableTo(z);
      @              x.compareTo(y) >= 0 && y.compareTo(z) >= 0
      @                 ==> x.isComparableTo(z) && x.compareTo(z) >= 0);
      @ public instance invariant_redundantly
      @      (\forall TransitiveCompareTo x, y, z;
      @              x != null && y != null && z != null
      @              && x.isComparableTo(y) && y.isComparableTo(z);
      @              x.compareTo(y) > 0 && y.compareTo(z) > 0
      @                 ==> x.isComparableTo(z) && x.compareTo(z) > 0);
      @*/

}
